<template>
    <div>
        <NavLinks :links="links" :current="textContent.nav.card_list" />
        <QuestsFilter />
        <Pagination :page="page" :last_page="lastPage" />
        <QuestItem v-for="quest in items" :quest="quest" :key="quest.id" />
    </div>
</template>

<script>
import { mapActions, mapState } from "vuex";
import QuestItem from "@/components/Quests/QuestItem";
import Pagination from "@/components/Pagination";
import QuestsFilter from "@/components/Admin/QuestsFilter";
import NavLinks from "@/components/NavLinks";
import { textContent } from "@/utils/textContent";
import snackbar from "@/utils/snackbar";

export default {
    name: "QuestList",
    components: { NavLinks, QuestsFilter, Pagination, QuestItem },
    data: () => ({ textContent }),
    methods: {
        ...mapActions("quests", ["getQuestList"]),
        async getData(params) {
            try {
                await this.getQuestList(params);
            } catch (e) {
                snackbar(e);
            }
        },
    },
    computed: {
        ...mapState("quests", ["serverData"]),
        items() {
            return this.serverData?.data || [];
        },
        page() {
            return this.serverData?.current_page || 1;
        },
        lastPage() {
            return this.serverData?.last_page || 1;
        },
        links() {
            return [
                {
                    text: textContent.nav.general,
                    to: { name: "Welcome" },
                },
            ];
        },
    },
    watch: {
        "$route.query": {
            immediate: true,
            handler(params) {
                this.getData(params);
            },
        },
    },
};
</script>

<style scoped></style>
